﻿var RatyCellType = (function (_super) {
    __extends(RatyCellType, _super);
    function RatyCellType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    //自定义的属性
    RatyCellType.prototype.ScoreValue = null;

    RatyCellType.prototype.createContent = function () {
        var self = this;
        var element = this.CellElement;
        
        var container = $("<div id='" + this.ID + "'></div>");
        var innerContainer = $('<div id=' + this.ID + '_raty></div>'); 
        innerContainer.css("width", element.Width);
        innerContainer.css("height", element.Height);
        container.append(innerContainer);
        return container;
    };

    RatyCellType.prototype.getValueFromElement = function () {  
        return this.ScoreValue;
    };

    RatyCellType.prototype.setValueToElement = function (element, value) {
        if (typeof (value) === "number") {            
            $("#" + this.ID + "_raty").data('raty').score(value);
        }
    };

    //自定义函数
    RatyCellType.prototype.initPlug = function (value) {
        var info = this.getRatyCellTypeNum()
        var self = this;
        $("#" + this.ID + "_raty").raty({
            path: 'Plugins/评分插件-6_0_102_0/Resources/css/images',
            number: info.num,
            half: info.halfstar,
            hints:null,
            score: value
        });
        $("#" + this.ID + "_raty").on("click", function (e) {
            self.ScoreValue = $("#" + self.ID + "_raty").data('raty').score();
            self.commitValue();
        });        
    };


    RatyCellType.prototype.onLoad = function () {
        this.initPlug(0);
    };
    //自定义的方法
    RatyCellType.prototype.getRatyCellTypeNum = function () {
        var cellTypeMetaData = this.CellElement.CellType;
        var num = 5;        
        var halfstar = false;        
        if (cellTypeMetaData.StarNumber) {
            num = cellTypeMetaData.StarNumber;
        }
        if (cellTypeMetaData.HalfMode) {
            halfstar = true;
        }
       return {
           num: num,           
           halfstar: halfstar,           
        };
    }
    RatyCellType.prototype.disable = function () {
        _super.prototype.disable.call(this);
        $("#" + this.ID + "_raty").data('raty').readOnly(true);
    };

    RatyCellType.prototype.enable = function () {
        _super.prototype.enable.call(this);
        $("#" + this.ID + "_raty").data('raty').readOnly(false);
    };

    return RatyCellType;
}(Forguncy.CellTypeBase));

// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.Plugin.CellTypeHelper.registerCellType("RatyCellType.RatyCellType, RatyCellType", RatyCellType);